<p align="center">
    <img width="200" src="https://raw.githubusercontent.com/kyoto-framework/kyoto/master/logo.svg" />
</p>

<h1 align="center">kyoto</h1>

<p align="center">
    Go library for creating fast, SSR-first frontend avoiding vanilla templating downsides.
</p>

<p align="center">
    <a href="https://goreportcard.com/report/github.com/kyoto-framework/kyoto">
        <img src="https://goreportcard.com/badge/github.com/kyoto-framework/kyoto">
    </a>
    <a href="https://codecov.io/gh/kyoto-framework/kyoto">
        <img src="https://codecov.io/gh/kyoto-framework/kyoto/branch/master/graph/badge.svg?token=XVLKT20DP8">
    </a href="https://pkg.go.dev/github.com/kyoto-framework/kyoto">
        <img src="https://pkg.go.dev/badge/github.com/kyoto-framework/kyoto.svg">
    </a>
    <a href="https://opencollective.com/kyoto-framework">
        <img src="https://img.shields.io/opencollective/all/kyoto-framework?label=backers%20%26%20sponsors">
    </a>
    <img src="https://img.shields.io/github/license/kyoto-framework/kyoto">
</p>

<p align="center">
    <a href="https://pkg.go.dev/github.com/kyoto-framework/kyoto">Documentation</a>&nbsp;&bull; <a href="#team">Team</a>&nbsp;&bull; <a href="#contact">Contact</a>&nbsp;&bull; <a href="#support-us">Support us</a>
</p>

## Motivation

Creating asynchronous and dynamic layout parts is a complex problem for larger projects using `html/template`.
Library tries to simplify this process.

## What kyoto proposes?

- Organize code into configurable and standalone components structure
- Get rid of spaghetti inside of handlers
- Simple asynchronous lifecycle
- Built-in dynamics like Hotwire or Laravel Livewire
- Using a familiar built-in `html/template`
- Full control over project setup (minimal dependencies)
- 0kb JS payload without actions client (~8kb when including a client)

## Reasons to opt out

- API may change drastically between major versions
- You want to develop SPA/PWA
- You're just feeling OK with JS frameworks
- Not situable for a frontend with a lot of client-side logic

## Team

- Yurii Zinets: [github](https://github.com/yuriizinets)
- Viktor Korniichuk: [github](https://github.com/RowdyHcs)

## Contact

Email: info@kyoto.codes or yurii.zinets@icloud.com  
Telegram: [@yuriizinets](https://t.me/yuriizinets)

## Support us

Any project support is appreciated! Providing a feedback, pull requests, new ideas, whatever. Also, donations and sponsoring will help us to keep high updates frequency. Just send us a quick email or a message on contacts provided above.

If you have an option to donate us with a crypto, we have some addresses.

Bitcoin: `bc1qgxe4u799f8pdyzk65sqpq28xj0yc6g05ckhvkk`  
Ethereum: `0xEB2f24e830223bE081264e0c81fb5FD4DDD2B7B0`

Also, we have a page on open collective for backers support.

Open Collective: [https://opencollective.com/kyoto-framework](https://opencollective.com/kyoto-framework)